<style scoped>
button:disabled {
  opacity: 0.3;
}
</style>

<template>
  <div>
    <div class="card">
      <div class="card-body p-1 px-2">
        <div v-for="date in grouppedOptions" :key="date.date">
          <small>{{ date.date }}</small>
          <div v-for="room in date.rooms" :key="room.id" class="row no-gutters mb-2">
            <div class="col-auto pt-1 pr-2">{{ room.name }}</div>
            <div class="col">
              <app-session
                v-for="session in room.sessions"
                :key="session.id"
                :session="session"
                :register="participants"
                :selected="value.includes(session.id)"
                @select="select(session)"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { groupBy, keyBy } from "lodash-es";
import AppSession from "./session";
export default {
  components: { AppSession },
  props: {
    value: { type: Array, default: () => [] },
    participants: { type: Number, default: 0 },
    roomOptions: { type: Array, default: () => [] },
    sessionOptions: { type: Array, default: () => [] }
  },
  computed: {
    roomMap() {
      return keyBy(this.roomOptions, "id");
    },
    grouppedOptions() {
      const dates = groupBy(this.sessionOptions, x => x.date);
      return Object.keys(dates).map(date => {
        const rooms = groupBy(dates[date], x => x.room_id);
        return {
          date,
          rooms: Object.keys(rooms).map(id => {
            const room = this.roomMap[id];
            return {
              ...room,
              sessions: rooms[id]
            };
          })
        };
      });
    }
  },
  methods: {
    select(session) {
      if (this.value.includes(session.id)) {
        this.$emit("input", this.value.filter(x => x !== session.id));
      } else {
        this.$emit("input", [...this.value, session.id]);
      }
    }
  }
};
</script>